<!DOCTYPE html>
<html lang="en" th:lang="#{lang}" xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security">
<head>
    <!--CSS -->
    <link th:href="@{/css/lightpick.css}" rel="stylesheet" type="text/css">
    <link th:href="@{/css/jquery.timepicker.min.css}" rel="stylesheet" type="text/css">

    <!--<link  href="https://cdnjs.cloudflare.com/ajax/libs/fotorama/4.6.4/fotorama.css" rel="stylesheet">-->

    <!--/*/ <th:block th:include="fragments/layout :: head">
        </th:block> /*/-->


    <!--<script src="https://cdnjs.cloudflare.com/ajax/libs/fotorama/4.6.4/fotorama.js"></script>-->

    <!--SCRIPTS-->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
    <script th:src="@{/js/lightpick.js}" type="text/javascript"></script>
    <script th:src="@{/js/jquery.timepicker.min.js}" type="text/javascript"></script>
</head>
<body>

<div id="wrapper">

    <div th:replace="fragments/layout :: header('Nová výpůjčka', '/', '')"></div>

    <main id="main" class="container">


        <div class="flex-grow-1 p-2">

            <!--ALERTS-->
            <div th:replace="fragments/layout :: alerts"></div>

            <div>
                <form id="product-form" class="needs-validation" method="post" enctype="multipart/form-data"
                      autocomplete="off"
                      th:action="@{/admin/borrow/add}" th:object="${borrow}" th:fragment="productEdit(product)"
                      novalidate>

                    <!--PRODUCTS-->
                    <div class="mb-3 clearfix" id="productList" th:fragment="productList">
                        <label class="font-weight-bold mb-0 mt-1 mr-2">Produkty:</label>

                        <!--AUTOCOMPLETE PRODUCTS-->
                        <div class="productAutocompleteDiv autocomplete w-100 mb-1"
                             th:each="product, iStat : ${borrow.borrowProducts}">

                            <div class="d-flex flex-nowrap">
                                <!--<p class="col-form-label mx-3"
                                   th:text="${iStat.index + 1} + '.'">1.</p>-->
                                <input type="hidden" class="productHiddenInput"
                                       th:field="${borrow.borrowProducts[__${iStat.index}__].product.id}">
                                <input type="text" class="productNameInput form-control"
                                       th:tabindex="${iStat.index + 5}"
                                       placeholder="Název produktu nebo id" required
                                       th:field="${borrow.borrowProducts[__${iStat.index}__].product.name}">
                                <div th:if="${iStat.index > 0}" class="input-group-append">
                                    <button class="btn btn-outline-secondary" type="button" name="removeProduct"
                                            th:value="${iStat.index}" tabindex="-1">
                                        <i class="fas fa-trash"></i>
                                    </button>
                                </div>
                            </div>

                        </div>
                        <button type="button" name="addProduct" class="btn btn-sm btn-orange float-right">
                            <i class="fas fa-plus"></i>
                        </button>

                        <script th:inline="javascript">
                            /*<![CDATA[*/

                            /*USER AUTOCOMPLETE*/
                            $(".productAutocompleteDiv").each(function (index, elem) {
                                var jElem = $(elem);
                                productAutocomplete(jElem.find(".productNameInput").get(0), jElem.find(".productHiddenInput").get(0));
                            });

                            function replaceItems(html) {
                                $('#productList').replaceWith($(html));
                                refreshAccessories();
                            }

                            $('button[name="addProduct"]').click(function (event) {
                                event.preventDefault();
                                var data = $("#productList").find("input").serialize();
                                $.post('/admin/product/autocomplete/add', data, replaceItems);
                            });

                            $('button[name="removeProduct"]').click(function (event) {
                                event.preventDefault();
                                var data = $("#productList").find("input").serialize();
                                data += '&index=' + $(this).val();
                                $.post('/admin/product/autocomplete/remove', data, replaceItems);
                            });

                            function newUserClick() {
                                var productsIds = '';

                                var inputs = $('.productHiddenInput');

                                inputs.each(function (index, elem) {
                                    if (index > 0) {
                                        productsIds += ",";
                                    }
                                    productsIds += elem.value;
                                });

                                window.location = "/admin/user/new?rUrl=/admin/borrow/new?productIds=" + productsIds;
                            }

                            /*]]>*/
                        </script>
                    </div>

                    <!--USER-->
                    <div class="mb-3">
                        <div class="d-flex pb-1">
                            <label class="font-weight-bold mb-0 mt-1 mr-2">Zákazník:</label>
                            <div class="ml-auto">
                                <button type="button" class="btn btn-sm btn-outline-secondary" onclick="newUserClick()">
                                    <i class="fas fa-user-plus"></i>
                                    Nový zákazník
                                </button>
                            </div>
                        </div>

                        <!--AUTOCOMPLETE USER-->
                        <div class="autocomplete w-100">
                            <input id="customerInput" class="form-control" type="text"
                                   placeholder="Jméno, firma, email nebo telefon" tabindex="2" required
                                   th:value="${borrow.user != null ? borrow.user.getFullName() : ''}">
                            <input id="customerHdnId" type="hidden" th:field="*{user.id}">
                            <span class="text-danger invalid-feedback">zákazník je povinný</span>
                        </div>
                    </div>

                    <div id="productPart" th:fragment="productPart(borrow)">
                        <!--DATEPICKER-->
                        <div class="form-group">


                            <label class="font-weight-bold">Datum:</label>

                            <!--BORROW ERROR-->
                            <div id="borrowError" class="alert alert-danger alert-dismissible"
                                 th:classappend="${borrowErrorMessage} == null ? 'd-none' : ''"
                                 role="alert">
                                    <span id="borrowErrorMessage"
                                          th:text="${borrowErrorMessage != null ? borrowErrorMessage : ''}"></span>
                                <button type="button" class="close" onclick="closeAlert('#borrowError');">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>

                            <div class="d-flex">
                                <input type="hidden" name="fromDate" id="fromDateInputHdn" class="form-control">
                                <input type="hidden" name="toDate" id="toDateInputHdn" class="form-control">
                            </div>

                            <div class="w-100 mt-2">
                                <div class="form-group">
                                    <label for="fromDateInput">Od:</label>
                                    <div class="d-flex flex-nowrap">
                                        <div>
                                            <input type="text" id="fromDateInput" class="form-control"
                                                   disabled required>
                                        </div>
                                        <div class="ml-2">
                                            <input type="text" name="fromTime" id="fromTimeInput" class="form-control"
                                                   th:value="${T(cz.david.minirental.helpers.CalendarHelper).getCurrentTime()}"
                                                   onchange="fromTimeChange()" required>
                                        </div>
                                    </div>
                                </div>

                                <div class="form-group">
                                    <label for="toDateInput">Do:</label>
                                    <div class="d-flex flex-nowrap">
                                        <div>
                                            <input type="text" id="toDateInput" class="form-control"
                                                   disabled required>
                                        </div>
                                        <div class="ml-2">
                                            <input type="text" name="toTime" id="toTimeInput" class="form-control"
                                                   th:value="${T(cz.david.minirental.helpers.CalendarHelper).getCurrentTime()}"
                                                   onchange="toTimeChange()" required>
                                            <span class="text-danger invalid-feedback">čas musí být větší než počáteční</span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <!--ACCESSORY-->
                        <div id="accessories" class="form-group" th:fragment="accessories(borrow)">
                            <label class="font-weight-bold">Příslušenství:</label>
                            <div th:each="bProduct, iStatBP : ${borrow.borrowProducts}">

                                <label th:text="${bProduct.product.name}"></label>
                                    <div class="ml-2"
                                         th:each="accessory,iStatA : ${bProduct.accessories}">
                                        <label class="control control--checkbox">
                                            <span th:text="${accessory.name}"></span>
                                            <input type="checkbox" class="" th:value="${accessory.id}"
                                                   th:name="'borrowProducts['+ ${iStatBP.index} +'].accessories[' + ${iStatA.index} + '].id'"
                                                   tabindex="3"
                                                   th:checked="${accessory.offer}"/>
                                            <div class="control__indicator"></div>
                                        </label>
                                        <input type="hidden"
                                               th:field="${borrow.borrowProducts[__${iStatBP.index}__].accessories[__${iStatA.index}__].name}">
                                    </div>
                            </div>
                        </div>

                        <script th:inline="javascript">
                            /*<![CDATA[*/

                            if (document.getElementById('fromDateInputHdn')) {

                                var isSecondClick = false;

                                document.getElementById('fromDateInput').value = moment().format('DD.MM.YYYY');
                                document.getElementById('toDateInput').value = moment().add(1, 'd').format('DD.MM.YYYY');

                                var picker = new Lightpick({
                                    field: document.getElementById('fromDateInputHdn'),
                                    secondField: document.getElementById('toDateInputHdn'),
                                    singleDate: false,
                                    inline: true,
                                    format: "DD.MM.YYYY",
                                    lang: "cs",
                                    numberOfMonths: ($(window).width() > 750) ? 2 : 1,
                                    //minDate: moment(),
                                    separator: ";",
                                    selectForward: true,
                                    hoveringTooltip: false,
                                    startDate: moment(),
                                    endDate: moment().add(1, 'd'),
                                    /*maxDays: 31,*/
                                    onSelect: function (start, end) {
                                        document.getElementById('fromDateInput').value = start.format('DD.MM.YYYY');
                                        document.getElementById('toDateInput').value = end.format('DD.MM.YYYY');

                                        if (isSecondClick && end != null && start <= end) {
                                            var collisionDates = $('.lightpick__day.is-disabled.is-in-range');
                                            if (collisionDates.length > 0) {
                                                showCollisionDatesError(collisionDates);
                                            } else {
                                                var error = $('#borrowError');
                                                error.removeClass('show');
                                                error.addClass('d-none');
                                            }
                                        }

                                        checkDates();

                                        //if(end == null || start <= end) {
                                        isSecondClick = !isSecondClick;
                                        //}
                                    }
                                });
                            }

                            //TIMEPICKER
                            $('#fromTimeInput').timepicker({
                                'timeFormat': 'H:i'
                            });
                            $('#toTimeInput').timepicker({
                                'timeFormat': 'H:i'
                            });

                            /*]]>*/
                        </script>

                    </div>

                    <div class="d-flex flex-wrap">
                        <button id="borrowBtn" type="submit" onclick="checkDates()"
                                class="w-100 w-sm-auto btn btn-success ml-auto px-5" tabindex="5">
                            Vypůjčit
                        </button>
                    </div>

                </form>
            </div>

        </div>

    </main>
</div>

<!--FOOTER-->
<div th:replace="fragments/layout :: footer"></div>

<script>

    /*USER AUTOCOMPLETE*/
    userAutocomplete(document.getElementById("customerInput"), document.getElementById("customerHdnId"));

    var fromTimeInput = $('#fromTimeInput');
    var toTimeInput = $('#toTimeInput');
    var toTimeChanged = false;

    function fromTimeChange() {
        //pokud se druhý čas zatím neměnil, nastaví se čas z prvního vstupu
        if (!toTimeChanged) {
            toTimeInput.val(fromTimeInput.val());
        }
        checkDates();
    }

    function toTimeChange() {
        toTimeChanged = true;
        checkDates();
    }

    /*CHECK DATES*/
    function checkDates() {
        var fromDateString = $('#fromDateInput').val();
        var toDateString = $('#toDateInput').val();
        fromDateString = fromDateString + " " + fromTimeInput.val();
        toDateString = toDateString + " " + toTimeInput.val();

        var fromDate = moment(fromDateString, "DD.MM.YYYY HH:mm");
        var toDate = moment(toDateString, "DD.MM.YYYY HH:mm");

        if (toDate < fromDate) {
            document.getElementById('toTimeInput').setCustomValidity("invalid");
            return false;
        }
        document.getElementById('toTimeInput').setCustomValidity("");
        return true;
    }

</script>

</body>
</html>